#include <assert.h>

#include <aterm2.h>
#include <deprecated.h>
#include "Booleans.h"

/*{{{  typedefs */

typedef struct ATerm _SDFBool;
typedef struct ATerm _SDFBoolList;
typedef struct ATerm _SDFBoolElems;

/*}}}  */

/*{{{  void SDFinitBooleansApi(void) */

void SDFinitBooleansApi(void)
{
  init_Booleans_dict();
}

/*}}}  */

/*{{{  term conversion functions */

/*{{{  SDFBool SDFBoolFromTerm(ATerm t) */

SDFBool SDFBoolFromTerm(ATerm t)
{
  return (SDFBool)t;
}

/*}}}  */
/*{{{  ATerm SDFBoolToTerm(SDFBool arg) */

ATerm SDFBoolToTerm(SDFBool arg)
{
  return (ATerm)arg;
}

/*}}}  */
/*{{{  SDFBoolList SDFBoolListFromTerm(ATerm t) */

SDFBoolList SDFBoolListFromTerm(ATerm t)
{
  return (SDFBoolList)t;
}

/*}}}  */
/*{{{  ATerm SDFBoolListToTerm(SDFBoolList arg) */

ATerm SDFBoolListToTerm(SDFBoolList arg)
{
  return (ATerm)arg;
}

/*}}}  */
/*{{{  SDFBoolElems SDFBoolElemsFromTerm(ATerm t) */

SDFBoolElems SDFBoolElemsFromTerm(ATerm t)
{
  return (SDFBoolElems)t;
}

/*}}}  */
/*{{{  ATerm SDFBoolElemsToTerm(SDFBoolElems arg) */

ATerm SDFBoolElemsToTerm(SDFBoolElems arg)
{
  return (ATerm)arg;
}

/*}}}  */

/*}}}  */
/*{{{  constructors */

/*{{{  SDFBool SDFmakeBoolTrue() */

SDFBool SDFmakeBoolTrue()
{
  return (SDFBool)(ATerm)ATmakeAppl2(SDFafun0, (ATerm)ATmakeAppl3(SDFafun1, (ATerm)ATmakeList1((ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun3))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun6))), (ATerm)ATmakeAppl1(SDFafun7, (ATerm)ATmakeList1((ATerm)ATmakeAppl1(SDFafun8, (ATerm)ATmakeAppl1(SDFafun9, (ATerm)ATmakeAppl0(SDFafun3)))))), (ATerm)ATmakeList1((ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun3))));
}

/*}}}  */
/*{{{  SDFBool SDFmakeBoolFalse() */

SDFBool SDFmakeBoolFalse()
{
  return (SDFBool)(ATerm)ATmakeAppl2(SDFafun0, (ATerm)ATmakeAppl3(SDFafun1, (ATerm)ATmakeList1((ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun10))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun6))), (ATerm)ATmakeAppl1(SDFafun7, (ATerm)ATmakeList1((ATerm)ATmakeAppl1(SDFafun8, (ATerm)ATmakeAppl1(SDFafun9, (ATerm)ATmakeAppl0(SDFafun10)))))), (ATerm)ATmakeList1((ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun10))));
}

/*}}}  */
/*{{{  SDFBool SDFmakeBoolAnd(SDFBool left, SDFLayout wsAfterLeft, SDFLayout wsAfterAmp, SDFBool right) */

SDFBool SDFmakeBoolAnd(SDFBool left, SDFLayout wsAfterLeft, SDFLayout wsAfterAmp, SDFBool right)
{
  return (SDFBool)(ATerm)ATmakeAppl2(SDFafun0, (ATerm)ATmakeAppl3(SDFafun1, (ATerm)ATinsert(ATinsert(ATinsert(ATinsert(ATmakeList1((ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun6)))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun11, (ATerm)ATmakeAppl0(SDFafun12)))), (ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun13))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun11, (ATerm)ATmakeAppl0(SDFafun12)))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun6)))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun6))), (ATerm)ATmakeAppl1(SDFafun7, (ATerm)ATinsert(ATmakeList1((ATerm)ATmakeAppl1(SDFafun14, (ATerm)ATmakeAppl0(SDFafun15))), (ATerm)ATmakeAppl1(SDFafun8, (ATerm)ATmakeAppl1(SDFafun9, (ATerm)ATmakeAppl0(SDFafun16)))))), (ATerm)ATinsert(ATinsert(ATinsert(ATinsert(ATmakeList1((ATerm)right), (ATerm)wsAfterAmp), (ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun13))), (ATerm)wsAfterLeft), (ATerm)left));
}

/*}}}  */
/*{{{  SDFBool SDFmakeBoolOr(SDFBool left, SDFLayout wsAfterLeft, SDFLayout wsAfterBar, SDFBool right) */

SDFBool SDFmakeBoolOr(SDFBool left, SDFLayout wsAfterLeft, SDFLayout wsAfterBar, SDFBool right)
{
  return (SDFBool)(ATerm)ATmakeAppl2(SDFafun0, (ATerm)ATmakeAppl3(SDFafun1, (ATerm)ATinsert(ATinsert(ATinsert(ATinsert(ATmakeList1((ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun6)))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun11, (ATerm)ATmakeAppl0(SDFafun12)))), (ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun17))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun11, (ATerm)ATmakeAppl0(SDFafun12)))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun6)))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun6))), (ATerm)ATmakeAppl1(SDFafun7, (ATerm)ATinsert(ATmakeList1((ATerm)ATmakeAppl1(SDFafun14, (ATerm)ATmakeAppl0(SDFafun15))), (ATerm)ATmakeAppl1(SDFafun8, (ATerm)ATmakeAppl1(SDFafun9, (ATerm)ATmakeAppl0(SDFafun18)))))), (ATerm)ATinsert(ATinsert(ATinsert(ATinsert(ATmakeList1((ATerm)right), (ATerm)wsAfterBar), (ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun17))), (ATerm)wsAfterLeft), (ATerm)left));
}

/*}}}  */
/*{{{  SDFBoolList SDFmakeBoolListList(SDFLayout wsAfterBracketOpen, SDFBoolElems elems, SDFLayout wsAfterElems) */

SDFBoolList SDFmakeBoolListList(SDFLayout wsAfterBracketOpen, SDFBoolElems elems, SDFLayout wsAfterElems)
{
  return (SDFBoolList)(ATerm)ATmakeAppl2(SDFafun0, (ATerm)ATmakeAppl3(SDFafun1, (ATerm)ATinsert(ATinsert(ATinsert(ATinsert(ATmakeList1((ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun19))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun11, (ATerm)ATmakeAppl0(SDFafun12)))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl2(SDFafun20, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun6)), (ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun21))))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun11, (ATerm)ATmakeAppl0(SDFafun12)))), (ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun22))), (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun23))), (ATerm)ATmakeAppl1(SDFafun7, (ATerm)ATmakeList1((ATerm)ATmakeAppl1(SDFafun8, (ATerm)ATmakeAppl1(SDFafun9, (ATerm)ATmakeAppl0(SDFafun24)))))), (ATerm)ATinsert(ATinsert(ATinsert(ATinsert(ATmakeList1((ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun19))), (ATerm)wsAfterElems), (ATerm)ATmakeAppl2(SDFafun0, (ATerm)ATmakeAppl1(SDFafun25, (ATerm)ATmakeAppl1(SDFafun4, (ATerm)ATmakeAppl2(SDFafun20, (ATerm)ATmakeAppl1(SDFafun5, (ATerm)ATmakeAppl0(SDFafun6)), (ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun21))))), (ATerm)elems)), (ATerm)wsAfterBracketOpen), (ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(SDFafun22))));
}

/*}}}  */
/*{{{  SDFBoolElems SDFmakeBoolElemsEmpty() */

SDFBoolElems SDFmakeBoolElemsEmpty()
{
  return (SDFBoolElems)(ATerm)ATempty;
}

/*}}}  */
/*{{{  SDFBoolElems SDFmakeBoolElemsSingle(SDFBool head) */

SDFBoolElems SDFmakeBoolElemsSingle(SDFBool head)
{
  return (SDFBoolElems)(ATerm)ATmakeList1((ATerm)head);
}

/*}}}  */
/*{{{  SDFBoolElems SDFmakeBoolElemsMany(SDFBool head, SDFLayout wsAfterFirst, char * sep, SDFLayout wsAfterSep, SDFBoolElems tail) */

SDFBoolElems SDFmakeBoolElemsMany(SDFBool head, SDFLayout wsAfterFirst, char * sep, SDFLayout wsAfterSep, SDFBoolElems tail)
{
  return (SDFBoolElems)(ATerm)ATinsert(ATinsert(ATinsert(ATinsert((ATermList)tail, (ATerm)wsAfterSep), (ATerm)ATmakeAppl1(SDFafun2, (ATerm)ATmakeAppl0(ATmakeAFun(sep, 0, ATtrue)))), (ATerm)wsAfterFirst), (ATerm)head);
}

/*}}}  */

/*}}}  */
/*{{{  equality functions */

ATbool SDFisEqualBool(SDFBool arg0, SDFBool arg1)
{
  return ATisEqual((ATerm)arg0, (ATerm)arg1);
}

ATbool SDFisEqualBoolList(SDFBoolList arg0, SDFBoolList arg1)
{
  return ATisEqual((ATerm)arg0, (ATerm)arg1);
}

ATbool SDFisEqualBoolElems(SDFBoolElems arg0, SDFBoolElems arg1)
{
  return ATisEqual((ATerm)arg0, (ATerm)arg1);
}

/*}}}  */
/*{{{  SDFBool accessors */

/*{{{  ATbool SDFisValidBool(SDFBool arg) */

ATbool SDFisValidBool(SDFBool arg)
{
  if (SDFisBoolTrue(arg)) {
    return ATtrue;
  }
  else if (SDFisBoolFalse(arg)) {
    return ATtrue;
  }
  else if (SDFisBoolAnd(arg)) {
    return ATtrue;
  }
  else if (SDFisBoolOr(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  inline ATbool SDFisBoolTrue(SDFBool arg) */

inline ATbool SDFisBoolTrue(SDFBool arg)
{
  {
    static ATerm last_arg = NULL;
    static int last_gc = -1;
    static ATbool last_result;

    assert(arg != NULL);

    if (last_gc != ATgetGCCount() || (ATerm)arg != last_arg) {
      last_arg = (ATerm)arg;
      last_result = ATmatchTerm((ATerm)arg, SDFpatternBoolTrue);
      last_gc = ATgetGCCount();
    }

    return last_result;
  }
}

/*}}}  */
/*{{{  inline ATbool SDFisBoolFalse(SDFBool arg) */

inline ATbool SDFisBoolFalse(SDFBool arg)
{
  {
    static ATerm last_arg = NULL;
    static int last_gc = -1;
    static ATbool last_result;

    assert(arg != NULL);

    if (last_gc != ATgetGCCount() || (ATerm)arg != last_arg) {
      last_arg = (ATerm)arg;
      last_result = ATmatchTerm((ATerm)arg, SDFpatternBoolFalse);
      last_gc = ATgetGCCount();
    }

    return last_result;
  }
}

/*}}}  */
/*{{{  inline ATbool SDFisBoolAnd(SDFBool arg) */

inline ATbool SDFisBoolAnd(SDFBool arg)
{
  {
    static ATerm last_arg = NULL;
    static int last_gc = -1;
    static ATbool last_result;

    assert(arg != NULL);

    if (last_gc != ATgetGCCount() || (ATerm)arg != last_arg) {
      last_arg = (ATerm)arg;
      last_result = ATmatchTerm((ATerm)arg, SDFpatternBoolAnd, NULL, NULL, NULL, NULL);
      last_gc = ATgetGCCount();
    }

    return last_result;
  }
}

/*}}}  */
/*{{{  inline ATbool SDFisBoolOr(SDFBool arg) */

inline ATbool SDFisBoolOr(SDFBool arg)
{
  {
    static ATerm last_arg = NULL;
    static int last_gc = -1;
    static ATbool last_result;

    assert(arg != NULL);

    if (last_gc != ATgetGCCount() || (ATerm)arg != last_arg) {
      last_arg = (ATerm)arg;
      last_result = ATmatchTerm((ATerm)arg, SDFpatternBoolOr, NULL, NULL, NULL, NULL);
      last_gc = ATgetGCCount();
    }

    return last_result;
  }
}

/*}}}  */
/*{{{  ATbool SDFhasBoolLeft(SDFBool arg) */

ATbool SDFhasBoolLeft(SDFBool arg)
{
  if (SDFisBoolAnd(arg)) {
    return ATtrue;
  }
  else if (SDFisBoolOr(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFBool SDFgetBoolLeft(SDFBool arg) */

SDFBool SDFgetBoolLeft(SDFBool arg)
{
  if (SDFisBoolAnd(arg)) {
    return (SDFBool)ATgetFirst((ATermList)ATgetArgument((ATermAppl)arg, 1));
  }
  else 
    return (SDFBool)ATgetFirst((ATermList)ATgetArgument((ATermAppl)arg, 1));
}

/*}}}  */
/*{{{  SDFBool SDFsetBoolLeft(SDFBool arg, SDFBool left) */

SDFBool SDFsetBoolLeft(SDFBool arg, SDFBool left)
{
  if (SDFisBoolAnd(arg)) {
    return (SDFBool)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)left, 0), 1);
  }
  else if (SDFisBoolOr(arg)) {
    return (SDFBool)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)left, 0), 1);
  }

  ATabort("Bool has no Left: %t\n", arg);
  return (SDFBool)NULL;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolWsAfterLeft(SDFBool arg) */

ATbool SDFhasBoolWsAfterLeft(SDFBool arg)
{
  if (SDFisBoolAnd(arg)) {
    return ATtrue;
  }
  else if (SDFisBoolOr(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFLayout SDFgetBoolWsAfterLeft(SDFBool arg) */

SDFLayout SDFgetBoolWsAfterLeft(SDFBool arg)
{
  if (SDFisBoolAnd(arg)) {
    return (SDFLayout)ATelementAt((ATermList)ATgetArgument((ATermAppl)arg, 1), 1);
  }
  else 
    return (SDFLayout)ATelementAt((ATermList)ATgetArgument((ATermAppl)arg, 1), 1);
}

/*}}}  */
/*{{{  SDFBool SDFsetBoolWsAfterLeft(SDFBool arg, SDFLayout wsAfterLeft) */

SDFBool SDFsetBoolWsAfterLeft(SDFBool arg, SDFLayout wsAfterLeft)
{
  if (SDFisBoolAnd(arg)) {
    return (SDFBool)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)wsAfterLeft, 1), 1);
  }
  else if (SDFisBoolOr(arg)) {
    return (SDFBool)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)wsAfterLeft, 1), 1);
  }

  ATabort("Bool has no WsAfterLeft: %t\n", arg);
  return (SDFBool)NULL;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolWsAfterAmp(SDFBool arg) */

ATbool SDFhasBoolWsAfterAmp(SDFBool arg)
{
  if (SDFisBoolAnd(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFLayout SDFgetBoolWsAfterAmp(SDFBool arg) */

SDFLayout SDFgetBoolWsAfterAmp(SDFBool arg)
{
  
    return (SDFLayout)ATelementAt((ATermList)ATgetArgument((ATermAppl)arg, 1), 3);
}

/*}}}  */
/*{{{  SDFBool SDFsetBoolWsAfterAmp(SDFBool arg, SDFLayout wsAfterAmp) */

SDFBool SDFsetBoolWsAfterAmp(SDFBool arg, SDFLayout wsAfterAmp)
{
  if (SDFisBoolAnd(arg)) {
    return (SDFBool)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)wsAfterAmp, 3), 1);
  }

  ATabort("Bool has no WsAfterAmp: %t\n", arg);
  return (SDFBool)NULL;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolRight(SDFBool arg) */

ATbool SDFhasBoolRight(SDFBool arg)
{
  if (SDFisBoolAnd(arg)) {
    return ATtrue;
  }
  else if (SDFisBoolOr(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFBool SDFgetBoolRight(SDFBool arg) */

SDFBool SDFgetBoolRight(SDFBool arg)
{
  if (SDFisBoolAnd(arg)) {
    return (SDFBool)ATelementAt((ATermList)ATgetArgument((ATermAppl)arg, 1), 4);
  }
  else 
    return (SDFBool)ATelementAt((ATermList)ATgetArgument((ATermAppl)arg, 1), 4);
}

/*}}}  */
/*{{{  SDFBool SDFsetBoolRight(SDFBool arg, SDFBool right) */

SDFBool SDFsetBoolRight(SDFBool arg, SDFBool right)
{
  if (SDFisBoolAnd(arg)) {
    return (SDFBool)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)right, 4), 1);
  }
  else if (SDFisBoolOr(arg)) {
    return (SDFBool)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)right, 4), 1);
  }

  ATabort("Bool has no Right: %t\n", arg);
  return (SDFBool)NULL;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolWsAfterBar(SDFBool arg) */

ATbool SDFhasBoolWsAfterBar(SDFBool arg)
{
  if (SDFisBoolOr(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFLayout SDFgetBoolWsAfterBar(SDFBool arg) */

SDFLayout SDFgetBoolWsAfterBar(SDFBool arg)
{
  
    return (SDFLayout)ATelementAt((ATermList)ATgetArgument((ATermAppl)arg, 1), 3);
}

/*}}}  */
/*{{{  SDFBool SDFsetBoolWsAfterBar(SDFBool arg, SDFLayout wsAfterBar) */

SDFBool SDFsetBoolWsAfterBar(SDFBool arg, SDFLayout wsAfterBar)
{
  if (SDFisBoolOr(arg)) {
    return (SDFBool)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)wsAfterBar, 3), 1);
  }

  ATabort("Bool has no WsAfterBar: %t\n", arg);
  return (SDFBool)NULL;
}

/*}}}  */

/*}}}  */
/*{{{  SDFBoolList accessors */

/*{{{  ATbool SDFisValidBoolList(SDFBoolList arg) */

ATbool SDFisValidBoolList(SDFBoolList arg)
{
  if (SDFisBoolListList(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  inline ATbool SDFisBoolListList(SDFBoolList arg) */

inline ATbool SDFisBoolListList(SDFBoolList arg)
{
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, SDFpatternBoolListList, NULL, NULL, NULL));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolListWsAfterBracketOpen(SDFBoolList arg) */

ATbool SDFhasBoolListWsAfterBracketOpen(SDFBoolList arg)
{
  if (SDFisBoolListList(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFLayout SDFgetBoolListWsAfterBracketOpen(SDFBoolList arg) */

SDFLayout SDFgetBoolListWsAfterBracketOpen(SDFBoolList arg)
{
  
    return (SDFLayout)ATelementAt((ATermList)ATgetArgument((ATermAppl)arg, 1), 1);
}

/*}}}  */
/*{{{  SDFBoolList SDFsetBoolListWsAfterBracketOpen(SDFBoolList arg, SDFLayout wsAfterBracketOpen) */

SDFBoolList SDFsetBoolListWsAfterBracketOpen(SDFBoolList arg, SDFLayout wsAfterBracketOpen)
{
  if (SDFisBoolListList(arg)) {
    return (SDFBoolList)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)wsAfterBracketOpen, 1), 1);
  }

  ATabort("BoolList has no WsAfterBracketOpen: %t\n", arg);
  return (SDFBoolList)NULL;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolListElems(SDFBoolList arg) */

ATbool SDFhasBoolListElems(SDFBoolList arg)
{
  if (SDFisBoolListList(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFBoolElems SDFgetBoolListElems(SDFBoolList arg) */

SDFBoolElems SDFgetBoolListElems(SDFBoolList arg)
{
  
    return (SDFBoolElems)ATgetArgument((ATermAppl)ATelementAt((ATermList)ATgetArgument((ATermAppl)arg, 1), 2), 1);
}

/*}}}  */
/*{{{  SDFBoolList SDFsetBoolListElems(SDFBoolList arg, SDFBoolElems elems) */

SDFBoolList SDFsetBoolListElems(SDFBoolList arg, SDFBoolElems elems)
{
  if (SDFisBoolListList(arg)) {
    return (SDFBoolList)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)ATsetArgument((ATermAppl)ATelementAt((ATermList)ATgetArgument((ATermAppl)arg, 1), 2), (ATerm)elems, 1), 2), 1);
  }

  ATabort("BoolList has no Elems: %t\n", arg);
  return (SDFBoolList)NULL;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolListWsAfterElems(SDFBoolList arg) */

ATbool SDFhasBoolListWsAfterElems(SDFBoolList arg)
{
  if (SDFisBoolListList(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFLayout SDFgetBoolListWsAfterElems(SDFBoolList arg) */

SDFLayout SDFgetBoolListWsAfterElems(SDFBoolList arg)
{
  
    return (SDFLayout)ATelementAt((ATermList)ATgetArgument((ATermAppl)arg, 1), 3);
}

/*}}}  */
/*{{{  SDFBoolList SDFsetBoolListWsAfterElems(SDFBoolList arg, SDFLayout wsAfterElems) */

SDFBoolList SDFsetBoolListWsAfterElems(SDFBoolList arg, SDFLayout wsAfterElems)
{
  if (SDFisBoolListList(arg)) {
    return (SDFBoolList)ATsetArgument((ATermAppl)arg, (ATerm)ATreplace((ATermList)ATgetArgument((ATermAppl)arg, 1), (ATerm)wsAfterElems, 3), 1);
  }

  ATabort("BoolList has no WsAfterElems: %t\n", arg);
  return (SDFBoolList)NULL;
}

/*}}}  */

/*}}}  */
/*{{{  SDFBoolElems accessors */

/*{{{  ATbool SDFisValidBoolElems(SDFBoolElems arg) */

ATbool SDFisValidBoolElems(SDFBoolElems arg)
{
  if (SDFisBoolElemsEmpty(arg)) {
    return ATtrue;
  }
  else if (SDFisBoolElemsSingle(arg)) {
    return ATtrue;
  }
  else if (SDFisBoolElemsMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  inline ATbool SDFisBoolElemsEmpty(SDFBoolElems arg) */

inline ATbool SDFisBoolElemsEmpty(SDFBoolElems arg)
{
  if (!ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
#ifndef DISABLE_DYNAMIC_CHECKING
  assert(arg != NULL);
  assert(ATmatchTerm((ATerm)arg, SDFpatternBoolElemsEmpty));
#endif
  return ATtrue;
}

/*}}}  */
/*{{{  inline ATbool SDFisBoolElemsSingle(SDFBoolElems arg) */

inline ATbool SDFisBoolElemsSingle(SDFBoolElems arg)
{
  if (ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
  {
    static ATerm last_arg = NULL;
    static int last_gc = -1;
    static ATbool last_result;

    assert(arg != NULL);

    if (last_gc != ATgetGCCount() || (ATerm)arg != last_arg) {
      last_arg = (ATerm)arg;
      last_result = ATmatchTerm((ATerm)arg, SDFpatternBoolElemsSingle, NULL);
      last_gc = ATgetGCCount();
    }

    return last_result;
  }
}

/*}}}  */
/*{{{  inline ATbool SDFisBoolElemsMany(SDFBoolElems arg) */

inline ATbool SDFisBoolElemsMany(SDFBoolElems arg)
{
  if (ATisEmpty((ATermList)arg)) {
    return ATfalse;
  }
  {
    static ATerm last_arg = NULL;
    static int last_gc = -1;
    static ATbool last_result;

    assert(arg != NULL);

    if (last_gc != ATgetGCCount() || (ATerm)arg != last_arg) {
      last_arg = (ATerm)arg;
      last_result = ATmatchTerm((ATerm)arg, SDFpatternBoolElemsMany, NULL, NULL, NULL, NULL, NULL);
      last_gc = ATgetGCCount();
    }

    return last_result;
  }
}

/*}}}  */
/*{{{  ATbool SDFhasBoolElemsHead(SDFBoolElems arg) */

ATbool SDFhasBoolElemsHead(SDFBoolElems arg)
{
  if (SDFisBoolElemsSingle(arg)) {
    return ATtrue;
  }
  else if (SDFisBoolElemsMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFBool SDFgetBoolElemsHead(SDFBoolElems arg) */

SDFBool SDFgetBoolElemsHead(SDFBoolElems arg)
{
  if (SDFisBoolElemsSingle(arg)) {
    return (SDFBool)ATgetFirst((ATermList)arg);
  }
  else 
    return (SDFBool)ATgetFirst((ATermList)arg);
}

/*}}}  */
/*{{{  SDFBoolElems SDFsetBoolElemsHead(SDFBoolElems arg, SDFBool head) */

SDFBoolElems SDFsetBoolElemsHead(SDFBoolElems arg, SDFBool head)
{
  if (SDFisBoolElemsSingle(arg)) {
    return (SDFBoolElems)ATreplace((ATermList)arg, (ATerm)head, 0);
  }
  else if (SDFisBoolElemsMany(arg)) {
    return (SDFBoolElems)ATreplace((ATermList)arg, (ATerm)head, 0);
  }

  ATabort("BoolElems has no Head: %t\n", arg);
  return (SDFBoolElems)NULL;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolElemsWsAfterFirst(SDFBoolElems arg) */

ATbool SDFhasBoolElemsWsAfterFirst(SDFBoolElems arg)
{
  if (SDFisBoolElemsMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFLayout SDFgetBoolElemsWsAfterFirst(SDFBoolElems arg) */

SDFLayout SDFgetBoolElemsWsAfterFirst(SDFBoolElems arg)
{
  
    return (SDFLayout)ATelementAt((ATermList)arg, 1);
}

/*}}}  */
/*{{{  SDFBoolElems SDFsetBoolElemsWsAfterFirst(SDFBoolElems arg, SDFLayout wsAfterFirst) */

SDFBoolElems SDFsetBoolElemsWsAfterFirst(SDFBoolElems arg, SDFLayout wsAfterFirst)
{
  if (SDFisBoolElemsMany(arg)) {
    return (SDFBoolElems)ATreplace((ATermList)arg, (ATerm)wsAfterFirst, 1);
  }

  ATabort("BoolElems has no WsAfterFirst: %t\n", arg);
  return (SDFBoolElems)NULL;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolElemsSep(SDFBoolElems arg) */

ATbool SDFhasBoolElemsSep(SDFBoolElems arg)
{
  if (SDFisBoolElemsMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  char * SDFgetBoolElemsSep(SDFBoolElems arg) */

char * SDFgetBoolElemsSep(SDFBoolElems arg)
{
  
    return (char *)ATgetName(ATgetAFun((ATermAppl)ATgetArgument((ATermAppl)ATelementAt((ATermList)arg, 2), 0)));
}

/*}}}  */
/*{{{  SDFBoolElems SDFsetBoolElemsSep(SDFBoolElems arg, char * sep) */

SDFBoolElems SDFsetBoolElemsSep(SDFBoolElems arg, char * sep)
{
  if (SDFisBoolElemsMany(arg)) {
    return (SDFBoolElems)ATreplace((ATermList)arg, (ATerm)ATsetArgument((ATermAppl)ATelementAt((ATermList)arg, 2), (ATerm)ATmakeAppl0(ATmakeAFun(sep, 0, ATtrue)), 0), 2);
  }

  ATabort("BoolElems has no Sep: %t\n", arg);
  return (SDFBoolElems)NULL;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolElemsWsAfterSep(SDFBoolElems arg) */

ATbool SDFhasBoolElemsWsAfterSep(SDFBoolElems arg)
{
  if (SDFisBoolElemsMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFLayout SDFgetBoolElemsWsAfterSep(SDFBoolElems arg) */

SDFLayout SDFgetBoolElemsWsAfterSep(SDFBoolElems arg)
{
  
    return (SDFLayout)ATelementAt((ATermList)arg, 3);
}

/*}}}  */
/*{{{  SDFBoolElems SDFsetBoolElemsWsAfterSep(SDFBoolElems arg, SDFLayout wsAfterSep) */

SDFBoolElems SDFsetBoolElemsWsAfterSep(SDFBoolElems arg, SDFLayout wsAfterSep)
{
  if (SDFisBoolElemsMany(arg)) {
    return (SDFBoolElems)ATreplace((ATermList)arg, (ATerm)wsAfterSep, 3);
  }

  ATabort("BoolElems has no WsAfterSep: %t\n", arg);
  return (SDFBoolElems)NULL;
}

/*}}}  */
/*{{{  ATbool SDFhasBoolElemsTail(SDFBoolElems arg) */

ATbool SDFhasBoolElemsTail(SDFBoolElems arg)
{
  if (SDFisBoolElemsMany(arg)) {
    return ATtrue;
  }
  return ATfalse;
}

/*}}}  */
/*{{{  SDFBoolElems SDFgetBoolElemsTail(SDFBoolElems arg) */

SDFBoolElems SDFgetBoolElemsTail(SDFBoolElems arg)
{
  
    return (SDFBoolElems)ATgetTail((ATermList)arg, 4);
}

/*}}}  */
/*{{{  SDFBoolElems SDFsetBoolElemsTail(SDFBoolElems arg, SDFBoolElems tail) */

SDFBoolElems SDFsetBoolElemsTail(SDFBoolElems arg, SDFBoolElems tail)
{
  if (SDFisBoolElemsMany(arg)) {
    return (SDFBoolElems)ATreplaceTail((ATermList)arg, (ATermList)tail, 4);
  }

  ATabort("BoolElems has no Tail: %t\n", arg);
  return (SDFBoolElems)NULL;
}

/*}}}  */

/*}}}  */
/*{{{  sort visitors */

/*{{{  SDFBool SDFvisitBool(SDFBool arg, SDFLayout (*acceptWsAfterLeft)(SDFLayout), SDFLayout (*acceptWsAfterAmp)(SDFLayout), SDFLayout (*acceptWsAfterBar)(SDFLayout)) */

SDFBool SDFvisitBool(SDFBool arg, SDFLayout (*acceptWsAfterLeft)(SDFLayout), SDFLayout (*acceptWsAfterAmp)(SDFLayout), SDFLayout (*acceptWsAfterBar)(SDFLayout))
{
  if (SDFisBoolTrue(arg)) {
    return SDFmakeBoolTrue();
  }
  if (SDFisBoolFalse(arg)) {
    return SDFmakeBoolFalse();
  }
  if (SDFisBoolAnd(arg)) {
    return SDFmakeBoolAnd(
        SDFvisitBool(SDFgetBoolLeft(arg), acceptWsAfterLeft, acceptWsAfterAmp, acceptWsAfterBar),
        acceptWsAfterLeft ? acceptWsAfterLeft(SDFgetBoolWsAfterLeft(arg)) : SDFgetBoolWsAfterLeft(arg),
        acceptWsAfterAmp ? acceptWsAfterAmp(SDFgetBoolWsAfterAmp(arg)) : SDFgetBoolWsAfterAmp(arg),
        SDFvisitBool(SDFgetBoolRight(arg), acceptWsAfterLeft, acceptWsAfterAmp, acceptWsAfterBar));
  }
  if (SDFisBoolOr(arg)) {
    return SDFmakeBoolOr(
        SDFvisitBool(SDFgetBoolLeft(arg), acceptWsAfterLeft, acceptWsAfterAmp, acceptWsAfterBar),
        acceptWsAfterLeft ? acceptWsAfterLeft(SDFgetBoolWsAfterLeft(arg)) : SDFgetBoolWsAfterLeft(arg),
        acceptWsAfterBar ? acceptWsAfterBar(SDFgetBoolWsAfterBar(arg)) : SDFgetBoolWsAfterBar(arg),
        SDFvisitBool(SDFgetBoolRight(arg), acceptWsAfterLeft, acceptWsAfterAmp, acceptWsAfterBar));
  }
  ATabort("not a Bool: %t\n", arg);
  return (SDFBool)NULL;
}

/*}}}  */
/*{{{  SDFBoolList SDFvisitBoolList(SDFBoolList arg, SDFLayout (*acceptWsAfterBracketOpen)(SDFLayout), SDFBoolElems (*acceptElems)(SDFBoolElems), SDFLayout (*acceptWsAfterElems)(SDFLayout)) */

SDFBoolList SDFvisitBoolList(SDFBoolList arg, SDFLayout (*acceptWsAfterBracketOpen)(SDFLayout), SDFBoolElems (*acceptElems)(SDFBoolElems), SDFLayout (*acceptWsAfterElems)(SDFLayout))
{
  if (SDFisBoolListList(arg)) {
    return SDFmakeBoolListList(
        acceptWsAfterBracketOpen ? acceptWsAfterBracketOpen(SDFgetBoolListWsAfterBracketOpen(arg)) : SDFgetBoolListWsAfterBracketOpen(arg),
        acceptElems ? acceptElems(SDFgetBoolListElems(arg)) : SDFgetBoolListElems(arg),
        acceptWsAfterElems ? acceptWsAfterElems(SDFgetBoolListWsAfterElems(arg)) : SDFgetBoolListWsAfterElems(arg));
  }
  ATabort("not a BoolList: %t\n", arg);
  return (SDFBoolList)NULL;
}

/*}}}  */
/*{{{  SDFBoolElems SDFvisitBoolElems(SDFBoolElems arg, SDFBool (*acceptHead)(SDFBool), SDFLayout (*acceptWsAfterFirst)(SDFLayout), char * (*acceptSep)(char *), SDFLayout (*acceptWsAfterSep)(SDFLayout)) */

SDFBoolElems SDFvisitBoolElems(SDFBoolElems arg, SDFBool (*acceptHead)(SDFBool), SDFLayout (*acceptWsAfterFirst)(SDFLayout), char * (*acceptSep)(char *), SDFLayout (*acceptWsAfterSep)(SDFLayout))
{
  if (SDFisBoolElemsEmpty(arg)) {
    return SDFmakeBoolElemsEmpty();
  }
  if (SDFisBoolElemsSingle(arg)) {
    return SDFmakeBoolElemsSingle(
        acceptHead ? acceptHead(SDFgetBoolElemsHead(arg)) : SDFgetBoolElemsHead(arg));
  }
  if (SDFisBoolElemsMany(arg)) {
    return SDFmakeBoolElemsMany(
        acceptHead ? acceptHead(SDFgetBoolElemsHead(arg)) : SDFgetBoolElemsHead(arg),
        acceptWsAfterFirst ? acceptWsAfterFirst(SDFgetBoolElemsWsAfterFirst(arg)) : SDFgetBoolElemsWsAfterFirst(arg),
        acceptSep ? acceptSep(SDFgetBoolElemsSep(arg)) : SDFgetBoolElemsSep(arg),
        acceptWsAfterSep ? acceptWsAfterSep(SDFgetBoolElemsWsAfterSep(arg)) : SDFgetBoolElemsWsAfterSep(arg),
        SDFvisitBoolElems(SDFgetBoolElemsTail(arg), acceptHead, acceptWsAfterFirst, acceptSep, acceptWsAfterSep));
  }
  ATabort("not a BoolElems: %t\n", arg);
  return (SDFBoolElems)NULL;
}

/*}}}  */

/*}}}  */
